/* brain.c generated by valac 0.12.0, the Vala compiler
 * generated from brain.vala, do not modify */

/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2010  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <pasang.h>
#include <stdio.h>


#define PASANG_TYPE_CUT_OFF (pasang_cut_off_get_type ())

#define PASANG_TYPE_BRAIN_SPEC (pasang_brain_spec_get_type ())
typedef struct _PasangBrainSpec PasangBrainSpec;

#define PASANG_TYPE_BRAIN (pasang_brain_get_type ())
#define PASANG_BRAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PASANG_TYPE_BRAIN, PasangBrain))
#define PASANG_BRAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PASANG_TYPE_BRAIN, PasangBrainClass))
#define PASANG_IS_BRAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PASANG_TYPE_BRAIN))
#define PASANG_IS_BRAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PASANG_TYPE_BRAIN))
#define PASANG_BRAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PASANG_TYPE_BRAIN, PasangBrainClass))

typedef struct _PasangBrain PasangBrain;
typedef struct _PasangBrainClass PasangBrainClass;
typedef struct _PasangBrainPrivate PasangBrainPrivate;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_mutex_free0(var) ((var == NULL) ? NULL : (var = (g_mutex_free (var), NULL)))
#define _g_cond_free0(var) ((var == NULL) ? NULL : (var = (g_cond_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _pasang_game_iterator_unref0(var) ((var == NULL) ? NULL : (var = (pasang_game_iterator_unref (var), NULL)))

typedef enum  {
	PASANG_CUT_OFF_POSITIVE = 10000,
	PASANG_CUT_OFF_NEGATIVE = -10000
} PasangCutOff;

struct _PasangBrainSpec {
	gint thinking_time;
	gint thinking_depth;
	gint discernment;
};

struct _PasangBrain {
	GObject parent_instance;
	PasangBrainPrivate * priv;
};

struct _PasangBrainClass {
	GObjectClass parent_class;
};

struct _PasangBrainPrivate {
	glong ticket;
	GTimer* timer;
	PasangBrainSpec brain_spec;
	PasangGame* root;
	GThread* thinking_thread;
	GMutex* mutex;
	GCond* cond;
	gboolean exiting;
	gboolean stopping;
	gboolean thinking;
};


static gpointer pasang_brain_parent_class = NULL;

GType pasang_cut_off_get_type (void) G_GNUC_CONST;
GType pasang_brain_spec_get_type (void) G_GNUC_CONST;
PasangBrainSpec* pasang_brain_spec_dup (const PasangBrainSpec* self);
void pasang_brain_spec_free (PasangBrainSpec* self);
void pasang_brain_spec_init (PasangBrainSpec *self);
GType pasang_brain_get_type (void) G_GNUC_CONST;
#define PASANG_BRAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PASANG_TYPE_BRAIN, PasangBrainPrivate))
enum  {
	PASANG_BRAIN_DUMMY_PROPERTY
};
void pasang_brain_request_exit (PasangBrain* self);
PasangBrain* pasang_brain_new (void);
PasangBrain* pasang_brain_construct (GType object_type);
static void* pasang_brain_run (PasangBrain* self);
static gpointer _pasang_brain_run_gthread_func (gpointer self);
void pasang_brain_request_stop (PasangBrain* self);
void pasang_brain_request_think (PasangBrain* self, PasangGame* game, PasangBrainSpec* spec, glong* issued_ticked);
static PasangMove* pasang_brain_think (PasangBrain* self);
static gint pasang_brain_search (PasangBrain* self, gint ply, gint depth, gint max_time, gboolean* depth_reached, gint* nodes, PasangGame* game, gint my_cutoff, gint opponent_cutoff);
static PasangMove* pasang_brain_select_move_randomly (PasangBrain* self);
static void g_cclosure_user_marshal_VOID__LONG_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void pasang_brain_finalize (GObject* obj);


GType pasang_cut_off_get_type (void) {
	static volatile gsize pasang_cut_off_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_cut_off_type_id__volatile)) {
		static const GEnumValue values[] = {{PASANG_CUT_OFF_POSITIVE, "PASANG_CUT_OFF_POSITIVE", "positive"}, {PASANG_CUT_OFF_NEGATIVE, "PASANG_CUT_OFF_NEGATIVE", "negative"}, {0, NULL, NULL}};
		GType pasang_cut_off_type_id;
		pasang_cut_off_type_id = g_enum_register_static ("PasangCutOff", values);
		g_once_init_leave (&pasang_cut_off_type_id__volatile, pasang_cut_off_type_id);
	}
	return pasang_cut_off_type_id__volatile;
}


void pasang_brain_spec_init (PasangBrainSpec *self) {
	memset (self, 0, sizeof (PasangBrainSpec));
	(*self).thinking_time = 1;
	(*self).thinking_depth = 2;
	(*self).discernment = 2;
}


PasangBrainSpec* pasang_brain_spec_dup (const PasangBrainSpec* self) {
	PasangBrainSpec* dup;
	dup = g_new0 (PasangBrainSpec, 1);
	memcpy (dup, self, sizeof (PasangBrainSpec));
	return dup;
}


void pasang_brain_spec_free (PasangBrainSpec* self) {
	g_free (self);
}


GType pasang_brain_spec_get_type (void) {
	static volatile gsize pasang_brain_spec_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_brain_spec_type_id__volatile)) {
		GType pasang_brain_spec_type_id;
		pasang_brain_spec_type_id = g_boxed_type_register_static ("PasangBrainSpec", (GBoxedCopyFunc) pasang_brain_spec_dup, (GBoxedFreeFunc) pasang_brain_spec_free);
		g_once_init_leave (&pasang_brain_spec_type_id__volatile, pasang_brain_spec_type_id);
	}
	return pasang_brain_spec_type_id__volatile;
}


/**
     * The brain thinks using its own thread so that the GUI remains responsive.
     */
static gpointer _pasang_brain_run_gthread_func (gpointer self) {
	gpointer result;
	result = pasang_brain_run (self);
	return result;
}


PasangBrain* pasang_brain_construct (GType object_type) {
	PasangBrain * self = NULL;
	GThread* _tmp0_ = NULL;
	GThread* _tmp1_;
	GError * _inner_error_ = NULL;
	self = (PasangBrain*) g_object_new (object_type, NULL);
	self->priv->exiting = FALSE;
	self->priv->stopping = FALSE;
	self->priv->thinking = FALSE;
	_tmp0_ = g_thread_create (_pasang_brain_run_gthread_func, self, TRUE, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_THREAD_ERROR) {
			goto __catch0_g_thread_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	self->priv->thinking_thread = _tmp1_;
	goto __finally0;
	__catch0_g_thread_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stderr, "%s\n", e->message);
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


PasangBrain* pasang_brain_new (void) {
	return pasang_brain_construct (PASANG_TYPE_BRAIN);
}


/**
     * Request the thinking thread to exit. Wait for the request to be complied.
     */
void pasang_brain_request_exit (PasangBrain* self) {
	g_return_if_fail (self != NULL);
	self->priv->exiting = TRUE;
	self->priv->stopping = TRUE;
	g_mutex_lock (self->priv->mutex);
	{
		self->priv->thinking = FALSE;
		g_cond_signal (self->priv->cond);
	}
	g_mutex_unlock (self->priv->mutex);
	g_thread_join (self->priv->thinking_thread);
}


/**
     * Request the thinking thread to abandon on-going thinking. 
     * Wait for the request to be complied.
     */
void pasang_brain_request_stop (PasangBrain* self) {
	g_return_if_fail (self != NULL);
	self->priv->stopping = TRUE;
	g_mutex_lock (self->priv->mutex);
	{
		self->priv->stopping = FALSE;
	}
	g_mutex_unlock (self->priv->mutex);
}


/**
     * Request thinking on a new game configuration, killing any
     * on-going thinking prior to that.
     * This function returns its result via an out argument because the
     * result has to be set within the critical block. This alternative won't work:
     *    issued_ticket = request_think (game, vp)  <-- error
     * because the assignment is done outside the critical region.
     */
void pasang_brain_request_think (PasangBrain* self, PasangGame* game, PasangBrainSpec* spec, glong* issued_ticked) {
	glong _issued_ticked = 0L;
	PasangStage _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	_tmp0_ = pasang_game_get_stage (game);
	g_return_if_fail (_tmp0_ != PASANG_STAGE_GAME_OVER);
	self->priv->stopping = TRUE;
	g_mutex_lock (self->priv->mutex);
	{
		PasangGame* _tmp1_ = NULL;
		self->priv->stopping = FALSE;
		self->priv->thinking = TRUE;
		_tmp1_ = pasang_game_new_clone (game);
		_g_object_unref0 (self->priv->root);
		self->priv->root = _tmp1_;
		self->priv->ticket = self->priv->ticket + 1;
		_issued_ticked = self->priv->ticket;
		self->priv->brain_spec = *spec;
		g_cond_signal (self->priv->cond);
	}
	g_mutex_unlock (self->priv->mutex);
	if (issued_ticked) {
		*issued_ticked = _issued_ticked;
	}
}


/**
     * The task for the thinking thread. To stop this thread, call request_exit.
     */
static void* pasang_brain_run (PasangBrain* self) {
	void* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	while (TRUE) {
		if (!(!self->priv->exiting)) {
			break;
		}
		g_mutex_lock (self->priv->mutex);
		{
			if (self->priv->thinking) {
				PasangMove* _tmp0_ = NULL;
				PasangMove* response;
				_tmp0_ = pasang_brain_think (self);
				response = _tmp0_;
				if (!self->priv->stopping) {
					g_signal_emit_by_name (self, "got-move-signal", self->priv->ticket, response);
				}
				self->priv->thinking = FALSE;
				_g_object_unref0 (response);
			}
			if (!self->priv->exiting) {
				g_cond_wait (self->priv->cond, self->priv->mutex);
			}
		}
		g_mutex_unlock (self->priv->mutex);
	}
	result = NULL;
	return result;
}


/**
     * Perform iterative deepening, and then inject some randomness to 
     * the move selection.
     */
static PasangMove* pasang_brain_think (PasangBrain* self) {
	PasangMove* result = NULL;
	gint max_time;
	gint max_ply;
	gint _tmp0_;
	PasangMove* _tmp11_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	max_time = self->priv->brain_spec.thinking_time;
	max_ply = self->priv->brain_spec.thinking_depth * 2;
	pasang_game_generate_moves (self->priv->root);
	_tmp0_ = pasang_game_numMoves (self->priv->root);
	if (_tmp0_ == 1) {
		PasangMove* _tmp1_ = NULL;
		_tmp1_ = pasang_game_getMove (self->priv->root, 0);
		result = _tmp1_;
		return result;
	}
	{
		PasangGameIterator* _tmp2_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp2_ = pasang_game_iterator (self->priv->root);
		_move_it = _tmp2_;
		while (TRUE) {
			PasangMove* _tmp3_ = NULL;
			_tmp3_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp3_;
			if (!(move != NULL)) {
				break;
			}
			pasang_move_set_value (move, (gint) PASANG_CUT_OFF_NEGATIVE);
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	g_timer_reset (self->priv->timer);
	{
		gint depth;
		depth = 1;
		{
			gboolean _tmp4_;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				gboolean depth_reached;
				gint nodes;
				if (!_tmp4_) {
					depth++;
				}
				_tmp4_ = FALSE;
				if (!(depth < max_ply)) {
					break;
				}
				if (self->priv->stopping) {
					_tmp5_ = TRUE;
				} else {
					gdouble _tmp6_;
					_tmp6_ = g_timer_elapsed (self->priv->timer, NULL);
					_tmp5_ = _tmp6_ > max_time;
				}
				if (_tmp5_) {
					break;
				}
				depth_reached = FALSE;
				nodes = 0;
				pasang_brain_search (self, 0, depth, max_time, &depth_reached, &nodes, self->priv->root, (gint) PASANG_CUT_OFF_NEGATIVE, (gint) PASANG_CUT_OFF_NEGATIVE);
				{
					PasangGameIterator* _tmp7_ = NULL;
					PasangGameIterator* _move_it;
					PasangMove* move = NULL;
					_tmp7_ = pasang_game_iterator (self->priv->root);
					_move_it = _tmp7_;
					while (TRUE) {
						PasangMove* _tmp8_ = NULL;
						gint _tmp9_;
						gint32 _tmp10_;
						_tmp8_ = pasang_game_iterator_next_value (_move_it);
						_g_object_unref0 (move);
						move = _tmp8_;
						if (!(move != NULL)) {
							break;
						}
						_tmp9_ = pasang_move_get_value (move);
						_tmp10_ = g_random_int_range ((gint32) 0, (gint32) 10);
						pasang_move_set_value (move, (_tmp9_ * 10) + _tmp10_);
					}
					_g_object_unref0 (move);
					_pasang_game_iterator_unref0 (_move_it);
				}
				pasang_game_sort_moves (self->priv->root);
				if (!depth_reached) {
					break;
				}
			}
		}
	}
	_tmp11_ = pasang_brain_select_move_randomly (self);
	result = _tmp11_;
	return result;
}


/**
     * Search to the given depth. Return evaluation.
     * Side effect: each move of game evaluated.
     *              depth_reached set to true if ply == depth.
     *              nodes set to the number of nodes generated.
     */
static gint pasang_brain_search (PasangBrain* self, gint ply, gint depth, gint max_time, gboolean* depth_reached, gint* nodes, PasangGame* game, gint my_cutoff, gint opponent_cutoff) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	PasangStage _tmp1_;
	gint best_value;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (game != NULL, 0);
	_tmp1_ = pasang_game_get_stage (game);
	if (_tmp1_ == PASANG_STAGE_GAME_OVER) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = ply == depth;
	}
	if (_tmp0_) {
		gint _tmp2_;
		gint _tmp3_;
		if (ply == depth) {
			*depth_reached = TRUE;
		}
		_tmp2_ = pasang_game_get_player (game);
		_tmp3_ = pasang_game_get_player (game);
		result = game->score[_tmp2_] - game->score[1 - _tmp3_];
		return result;
	}
	best_value = (gint) PASANG_CUT_OFF_NEGATIVE;
	{
		PasangGameIterator* _tmp4_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp4_ = pasang_game_iterator (game);
		_move_it = _tmp4_;
		while (TRUE) {
			PasangMove* _tmp5_ = NULL;
			PasangGame* _tmp6_ = NULL;
			PasangGame* game2;
			gint _tmp7_ = 0;
			gboolean _tmp8_ = FALSE;
			gint _tmp9_;
			gboolean _tmp10_ = FALSE;
			gint _tmp13_;
			_tmp5_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp5_;
			if (!(move != NULL)) {
				break;
			}
			_tmp6_ = pasang_game_new_clone (game);
			game2 = _tmp6_;
			pasang_game_perform (game2, move, TRUE);
			if (ply < 3) {
				_tmp8_ = TRUE;
			} else {
				_tmp8_ = best_value > my_cutoff;
			}
			if (_tmp8_) {
				_tmp7_ = best_value;
			} else {
				_tmp7_ = my_cutoff;
			}
			_tmp9_ = pasang_brain_search (self, ply + 1, depth, max_time, depth_reached, nodes, game2, opponent_cutoff, _tmp7_);
			pasang_move_set_value (move, -_tmp9_);
			if (self->priv->stopping) {
				_tmp10_ = TRUE;
			} else {
				gboolean _tmp11_ = FALSE;
				*nodes = (*nodes) + 1;
				if (((*nodes) % 1024) == 0) {
					gdouble _tmp12_;
					_tmp12_ = g_timer_elapsed (self->priv->timer, NULL);
					_tmp11_ = _tmp12_ > max_time;
				} else {
					_tmp11_ = FALSE;
				}
				_tmp10_ = _tmp11_;
			}
			if (_tmp10_) {
				_g_object_unref0 (game2);
				break;
			}
			_tmp13_ = pasang_move_get_value (move);
			if (_tmp13_ > best_value) {
				gint _tmp14_;
				gboolean _tmp15_ = FALSE;
				_tmp14_ = pasang_move_get_value (move);
				best_value = _tmp14_;
				if (ply > 1) {
					_tmp15_ = best_value >= (-opponent_cutoff);
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					_g_object_unref0 (game2);
					break;
				}
			}
			_g_object_unref0 (game2);
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	result = best_value;
	return result;
}


/**
     * Provide some variability in the line of play.
     * Assume root's branches are sorted in descending values.
     */
static PasangMove* pasang_brain_select_move_randomly (PasangBrain* self) {
	PasangMove* result = NULL;
	gint discernment;
	gint _tmp4_;
	PasangMove* _tmp5_ = NULL;
	PasangMove* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint smallest_value;
	gint total;
	gint num_rolls;
	PasangStage _tmp12_;
	gint32 _tmp14_;
	gint roll;
	PasangMove* _tmp20_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	discernment = (self->priv->brain_spec.discernment - 1) * 5;
	{
		PasangGameIterator* _tmp0_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp0_ = pasang_game_iterator (self->priv->root);
		_move_it = _tmp0_;
		while (TRUE) {
			PasangMove* _tmp1_ = NULL;
			gint _tmp2_;
			_tmp1_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp1_;
			if (!(move != NULL)) {
				break;
			}
			_tmp2_ = pasang_move_get_value (move);
			if (_tmp2_ > 0) {
				gint _tmp3_;
				_tmp3_ = pasang_move_get_value (move);
				pasang_move_set_value (move, _tmp3_ + discernment);
			}
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	_tmp4_ = pasang_game_numMoves (self->priv->root);
	_tmp5_ = pasang_game_getMove (self->priv->root, _tmp4_ - 1);
	_tmp6_ = _tmp5_;
	_tmp7_ = pasang_move_get_value (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp6_);
	smallest_value = _tmp8_;
	total = 0;
	{
		PasangGameIterator* _tmp9_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp9_ = pasang_game_iterator (self->priv->root);
		_move_it = _tmp9_;
		while (TRUE) {
			PasangMove* _tmp10_ = NULL;
			gint _tmp11_;
			_tmp10_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp10_;
			if (!(move != NULL)) {
				break;
			}
			_tmp11_ = pasang_move_get_value (move);
			total = total + ((_tmp11_ - smallest_value) + 1);
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	num_rolls = self->priv->brain_spec.discernment;
	_tmp12_ = pasang_game_get_stage (self->priv->root);
	if (_tmp12_ == PASANG_STAGE_OPENING) {
		num_rolls = 1;
	} else {
		PasangStage _tmp13_;
		_tmp13_ = pasang_game_get_stage (self->priv->root);
		if (_tmp13_ == PASANG_STAGE_SELECT) {
			num_rolls = num_rolls / 2;
		}
	}
	_tmp14_ = g_random_int_range ((gint32) 0, (gint32) total);
	roll = (gint) _tmp14_;
	{
		gint i;
		i = 1;
		{
			gboolean _tmp15_;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint32 _tmp16_;
				gint roll2;
				if (!_tmp15_) {
					i++;
				}
				_tmp15_ = FALSE;
				if (!(i < num_rolls)) {
					break;
				}
				_tmp16_ = g_random_int_range ((gint32) 0, (gint32) total);
				roll2 = (gint) _tmp16_;
				if (roll > roll2) {
					roll = roll2;
				}
			}
		}
	}
	{
		PasangGameIterator* _tmp17_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp17_ = pasang_game_iterator (self->priv->root);
		_move_it = _tmp17_;
		while (TRUE) {
			PasangMove* _tmp18_ = NULL;
			gint _tmp19_;
			_tmp18_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp18_;
			if (!(move != NULL)) {
				break;
			}
			_tmp19_ = pasang_move_get_value (move);
			roll = roll - ((_tmp19_ - smallest_value) + 1);
			if (roll < 0) {
				result = move;
				_pasang_game_iterator_unref0 (_move_it);
				return result;
			}
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	_tmp20_ = pasang_game_getMove (self->priv->root, 0);
	result = _tmp20_;
	return result;
}


static void g_cclosure_user_marshal_VOID__LONG_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__LONG_OBJECT) (gpointer data1, glong arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__LONG_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__LONG_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_long (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void pasang_brain_class_init (PasangBrainClass * klass) {
	pasang_brain_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PasangBrainPrivate));
	G_OBJECT_CLASS (klass)->finalize = pasang_brain_finalize;
	/**
	     * After the non-blocking request_think(game, vp, out ticket), the client will be 
	     * notified using this signal. The client should ensure that the ticket sent by the
	     * signal matches the ticket issued by request_think.
	     */
	g_signal_new ("got_move_signal", PASANG_TYPE_BRAIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__LONG_OBJECT, G_TYPE_NONE, 2, G_TYPE_LONG, PASANG_TYPE_MOVE);
}


static void pasang_brain_instance_init (PasangBrain * self) {
	GTimer* _tmp0_ = NULL;
	GMutex* _tmp1_ = NULL;
	GCond* _tmp2_ = NULL;
	self->priv = PASANG_BRAIN_GET_PRIVATE (self);
	self->priv->ticket = (glong) 0;
	_tmp0_ = g_timer_new ();
	self->priv->timer = _tmp0_;
	_tmp1_ = g_mutex_new ();
	self->priv->mutex = _tmp1_;
	_tmp2_ = g_cond_new ();
	self->priv->cond = _tmp2_;
}


static void pasang_brain_finalize (GObject* obj) {
	PasangBrain * self;
	self = PASANG_BRAIN (obj);
	pasang_brain_request_exit (self);
	_g_timer_destroy0 (self->priv->timer);
	_g_object_unref0 (self->priv->root);
	_g_mutex_free0 (self->priv->mutex);
	_g_cond_free0 (self->priv->cond);
	G_OBJECT_CLASS (pasang_brain_parent_class)->finalize (obj);
}


GType pasang_brain_get_type (void) {
	static volatile gsize pasang_brain_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_brain_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PasangBrainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pasang_brain_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasangBrain), 0, (GInstanceInitFunc) pasang_brain_instance_init, NULL };
		GType pasang_brain_type_id;
		pasang_brain_type_id = g_type_register_static (G_TYPE_OBJECT, "PasangBrain", &g_define_type_info, 0);
		g_once_init_leave (&pasang_brain_type_id__volatile, pasang_brain_type_id);
	}
	return pasang_brain_type_id__volatile;
}



