/* game-view.c generated by valac 0.12.0, the Vala compiler
 * generated from game-view.vala, do not modify */

/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2010  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gtk/gtk.h>
#include <pasang.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>


#define PASANG_TYPE_PLAYER (pasang_player_get_type ())

#define PASANG_TYPE_PLAYER_SIDE (pasang_player_side_get_type ())

#define PASANG_TYPE_POINT (pasang_point_get_type ())
typedef struct _PasangPoint PasangPoint;

#define PASANG_TYPE_MOVE_SUBMISSION (pasang_move_submission_get_type ())

#define PASANG_TYPE_GAME_VIEW (pasang_game_view_get_type ())
#define PASANG_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PASANG_TYPE_GAME_VIEW, PasangGameView))
#define PASANG_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PASANG_TYPE_GAME_VIEW, PasangGameViewClass))
#define PASANG_IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PASANG_TYPE_GAME_VIEW))
#define PASANG_IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PASANG_TYPE_GAME_VIEW))
#define PASANG_GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PASANG_TYPE_GAME_VIEW, PasangGameViewClass))

typedef struct _PasangGameView PasangGameView;
typedef struct _PasangGameViewClass PasangGameViewClass;
typedef struct _PasangGameViewPrivate PasangGameViewPrivate;

#define PASANG_TYPE_THEME_SWITCH (pasang_theme_switch_get_type ())
#define PASANG_THEME_SWITCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PASANG_TYPE_THEME_SWITCH, PasangThemeSwitch))
#define PASANG_THEME_SWITCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PASANG_TYPE_THEME_SWITCH, PasangThemeSwitchClass))
#define PASANG_IS_THEME_SWITCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PASANG_TYPE_THEME_SWITCH))
#define PASANG_IS_THEME_SWITCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PASANG_TYPE_THEME_SWITCH))
#define PASANG_THEME_SWITCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PASANG_TYPE_THEME_SWITCH, PasangThemeSwitchClass))

typedef struct _PasangThemeSwitch PasangThemeSwitch;
typedef struct _PasangThemeSwitchClass PasangThemeSwitchClass;

#define PASANG_TYPE_THEME (pasang_theme_get_type ())
#define PASANG_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PASANG_TYPE_THEME, PasangTheme))
#define PASANG_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PASANG_TYPE_THEME, PasangThemeClass))
#define PASANG_IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PASANG_TYPE_THEME))
#define PASANG_IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PASANG_TYPE_THEME))
#define PASANG_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PASANG_TYPE_THEME, PasangThemeClass))

typedef struct _PasangTheme PasangTheme;
typedef struct _PasangThemeClass PasangThemeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _pasang_game_iterator_unref0(var) ((var == NULL) ? NULL : (var = (pasang_game_iterator_unref (var), NULL)))

typedef enum  {
	PASANG_PLAYER_AI,
	PASANG_PLAYER_HUMAN,
	PASANG_PLAYER_REMOTE
} PasangPlayer;

typedef enum  {
	PASANG_PLAYER_SIDE_TOP = 0,
	PASANG_PLAYER_SIDE_BOTTOM = 1
} PasangPlayerSide;

struct _PasangPoint {
	gint x;
	gint y;
};

typedef enum  {
	PASANG_MOVE_SUBMISSION_NULL,
	PASANG_MOVE_SUBMISSION_SUBMITTING,
	PASANG_MOVE_SUBMISSION_LIFTING
} PasangMoveSubmission;

struct _PasangGameView {
	GtkDrawingArea parent_instance;
	PasangGameViewPrivate * priv;
	PasangPoint kas_point;
};

struct _PasangGameViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _PasangGameViewPrivate {
	PasangGame* _game;
	PasangThemeSwitch* _theme_switch;
	PasangTheme* _theme;
	gboolean _rotated;
	PasangMove* _selected_move;
	PasangPlayer* player_types;
	gint player_types_length1;
	gint _player_types_size_;
	PasangPoint drag_point;
	gboolean simulating_mouse;
	GTimer* timer;
	gint simulated_press_pos;
	gint simulated_release_pos;
	PasangMoveSubmission move_submission;
};


static gpointer pasang_game_view_parent_class = NULL;

GType pasang_player_get_type (void) G_GNUC_CONST;
GType pasang_player_side_get_type (void) G_GNUC_CONST;
GType pasang_point_get_type (void) G_GNUC_CONST;
PasangPoint* pasang_point_dup (const PasangPoint* self);
void pasang_point_free (PasangPoint* self);
void pasang_point_init_xy (PasangPoint *self, gint x, gint y);
GType pasang_move_submission_get_type (void) G_GNUC_CONST;
GType pasang_game_view_get_type (void) G_GNUC_CONST;
GType pasang_theme_switch_get_type (void) G_GNUC_CONST;
GType pasang_theme_get_type (void) G_GNUC_CONST;
#define PASANG_GAME_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PASANG_TYPE_GAME_VIEW, PasangGameViewPrivate))
enum  {
	PASANG_GAME_VIEW_DUMMY_PROPERTY,
	PASANG_GAME_VIEW_GAME,
	PASANG_GAME_VIEW_THEME_SWITCH,
	PASANG_GAME_VIEW_THEME,
	PASANG_GAME_VIEW_ROTATED,
	PASANG_GAME_VIEW_SELECTED_MOVE,
	PASANG_GAME_VIEW_PLAYER_TYPE,
	PASANG_GAME_VIEW_PLAYER_SIDE
};
PasangThemeSwitch* pasang_theme_switch_new (void);
PasangThemeSwitch* pasang_theme_switch_construct (GType object_type);
PasangGameView* pasang_game_view_new (void);
PasangGameView* pasang_game_view_construct (GType object_type);
void pasang_game_view_set_turn (PasangGameView* self, PasangPlayer top_player, PasangPlayer bottom_player, gint first_player);
static gboolean _lambda8_ (GdkEventExpose* e, PasangGameView* self);
PasangTheme* pasang_game_view_get_theme (PasangGameView* self);
void pasang_theme_draw (PasangTheme* self, PasangGameView* game_view, GdkRectangle* area);
static gboolean __lambda8__gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self);
PasangThemeSwitch* pasang_game_view_get_theme_switch (PasangGameView* self);
void pasang_theme_switch_resize (PasangThemeSwitch* self, GdkRectangle* allocation);
static void _pasang_theme_switch_resize_gtk_widget_size_allocate (GtkWidget* _sender, GdkRectangle* allocation, gpointer self);
static void _lambda9_ (PasangGameView* self);
PasangTheme* pasang_theme_switch_get_theme (PasangThemeSwitch* self);
static void pasang_game_view_set_theme (PasangGameView* self, PasangTheme* value);
static void __lambda9__pasang_theme_switch_changed (PasangThemeSwitch* _sender, gpointer self);
static gboolean _lambda10_ (GtkWidget* s, GdkEventMotion* event, PasangGameView* self);
static gboolean pasang_game_view_get_input_allowed (PasangGameView* self);
static void pasang_game_view_mouse_moved (PasangGameView* self, PasangPoint* mouse);
static gboolean __lambda10__gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean _lambda11_ (GtkWidget* s, GdkEventButton* event, PasangGameView* self);
static void pasang_game_view_mouse_pressed (PasangGameView* self, PasangPoint* mouse);
static gboolean __lambda11__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean _lambda12_ (GtkWidget* s, GdkEventButton* event, PasangGameView* self);
static void pasang_game_view_mouse_released (PasangGameView* self, PasangPoint* mouse);
static gboolean __lambda12__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void pasang_game_view_init_state (PasangGameView* self);
static void pasang_game_view_set_selected_move (PasangGameView* self, PasangMove* value);
void pasang_theme_drop_pieces (PasangTheme* self);
void pasang_theme_drop_kas (PasangTheme* self, PasangGame* game);
PasangGame* pasang_game_view_get_game (PasangGameView* self);
void pasang_game_view_start_game (PasangGameView* self, const gchar* starting_pattern);
static void pasang_game_view_set_rotated (PasangGameView* self, gboolean value);
gint pasang_game_view_get_visual_score (PasangGameView* self, PasangPlayerSide ps);
gboolean pasang_game_view_get_rotated (PasangGameView* self);
void pasang_game_view_queue_draw_piece (PasangGameView* self, gint position);
static void pasang_game_view_to_point (PasangGameView* self, gint pos, PasangPoint* result);
gint pasang_theme_cell_width (PasangTheme* self);
gint pasang_theme_piece_image_width (PasangTheme* self, PasangPiece piece);
void pasang_game_view_queue_draw_kas (PasangGameView* self);
void pasang_theme_pick_booties (PasangTheme* self, PasangGame* game, PasangMove* move, gboolean full);
static PasangMove* pasang_game_view_find_move (PasangGameView* self, PasangPoint* mouse);
static gboolean pasang_game_view_drag_candidate (PasangGameView* self, PasangPoint* mouse);
static void pasang_game_view_drag_kas (PasangGameView* self, PasangPoint* mouse);
PasangMove* pasang_game_view_get_selected_move (PasangGameView* self);
static void pasang_game_view_submit_selected_move (PasangGameView* self);
static void pasang_game_view_pick_candidate (PasangGameView* self, PasangPoint* mouse);
static void pasang_game_view_pick_kas (PasangGameView* self, PasangPoint* mouse);
static void pasang_game_view_drop_candidate (PasangGameView* self, PasangPoint* mouse);
static void pasang_game_view_drop_kas (PasangGameView* self, PasangPoint* mouse);
static gint pasang_game_view_to_position (PasangGameView* self, PasangPoint* p);
static void pasang_game_view_perform_selected_move (PasangGameView* self);
PasangPlayer pasang_game_view_get_player_type (PasangGameView* self);
void pasang_theme_pick_kas (PasangTheme* self, PasangGame* game);
void pasang_theme_to_point (PasangTheme* self, gint pos, gboolean rotated, PasangPoint* result);
gint pasang_theme_to_position (PasangTheme* self, PasangGame* game, PasangPoint* p, gboolean rotated, gboolean precise);
void pasang_game_view_simulate (PasangGameView* self, PasangMove* move);
void pasang_game_view_stop_simulation (PasangGameView* self);
void pasang_game_view_animate (PasangGameView* self);
gdouble pasang_theme_get_time_span (PasangTheme* self);
static void pasang_game_view_animate_simulated_mouse_events (PasangGameView* self, gdouble lapse);
void pasang_theme_animate (PasangTheme* self, PasangGameView* game_view, gdouble lapse);
static void pasang_game_view_set_game (PasangGameView* self, PasangGame* value);
static void pasang_game_view_set_theme_switch (PasangGameView* self, PasangThemeSwitch* value);
PasangPlayerSide pasang_game_view_get_player_side (PasangGameView* self);
static void g_cclosure_user_marshal_VOID__ENUM_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void pasang_game_view_finalize (GObject* obj);
static void _vala_pasang_game_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pasang_game_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType pasang_player_get_type (void) {
	static volatile gsize pasang_player_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_player_type_id__volatile)) {
		static const GEnumValue values[] = {{PASANG_PLAYER_AI, "PASANG_PLAYER_AI", "ai"}, {PASANG_PLAYER_HUMAN, "PASANG_PLAYER_HUMAN", "human"}, {PASANG_PLAYER_REMOTE, "PASANG_PLAYER_REMOTE", "remote"}, {0, NULL, NULL}};
		GType pasang_player_type_id;
		pasang_player_type_id = g_enum_register_static ("PasangPlayer", values);
		g_once_init_leave (&pasang_player_type_id__volatile, pasang_player_type_id);
	}
	return pasang_player_type_id__volatile;
}


GType pasang_player_side_get_type (void) {
	static volatile gsize pasang_player_side_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_player_side_type_id__volatile)) {
		static const GEnumValue values[] = {{PASANG_PLAYER_SIDE_TOP, "PASANG_PLAYER_SIDE_TOP", "top"}, {PASANG_PLAYER_SIDE_BOTTOM, "PASANG_PLAYER_SIDE_BOTTOM", "bottom"}, {0, NULL, NULL}};
		GType pasang_player_side_type_id;
		pasang_player_side_type_id = g_enum_register_static ("PasangPlayerSide", values);
		g_once_init_leave (&pasang_player_side_type_id__volatile, pasang_player_side_type_id);
	}
	return pasang_player_side_type_id__volatile;
}


void pasang_point_init_xy (PasangPoint *self, gint x, gint y) {
	memset (self, 0, sizeof (PasangPoint));
	(*self).x = x;
	(*self).y = y;
}


PasangPoint* pasang_point_dup (const PasangPoint* self) {
	PasangPoint* dup;
	dup = g_new0 (PasangPoint, 1);
	memcpy (dup, self, sizeof (PasangPoint));
	return dup;
}


void pasang_point_free (PasangPoint* self) {
	g_free (self);
}


GType pasang_point_get_type (void) {
	static volatile gsize pasang_point_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_point_type_id__volatile)) {
		GType pasang_point_type_id;
		pasang_point_type_id = g_boxed_type_register_static ("PasangPoint", (GBoxedCopyFunc) pasang_point_dup, (GBoxedFreeFunc) pasang_point_free);
		g_once_init_leave (&pasang_point_type_id__volatile, pasang_point_type_id);
	}
	return pasang_point_type_id__volatile;
}


GType pasang_move_submission_get_type (void) {
	static volatile gsize pasang_move_submission_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_move_submission_type_id__volatile)) {
		static const GEnumValue values[] = {{PASANG_MOVE_SUBMISSION_NULL, "PASANG_MOVE_SUBMISSION_NULL", "null"}, {PASANG_MOVE_SUBMISSION_SUBMITTING, "PASANG_MOVE_SUBMISSION_SUBMITTING", "submitting"}, {PASANG_MOVE_SUBMISSION_LIFTING, "PASANG_MOVE_SUBMISSION_LIFTING", "lifting"}, {0, NULL, NULL}};
		GType pasang_move_submission_type_id;
		pasang_move_submission_type_id = g_enum_register_static ("PasangMoveSubmission", values);
		g_once_init_leave (&pasang_move_submission_type_id__volatile, pasang_move_submission_type_id);
	}
	return pasang_move_submission_type_id__volatile;
}


static gboolean _lambda8_ (GdkEventExpose* e, PasangGameView* self) {
	gboolean result = FALSE;
	pasang_theme_draw (self->priv->_theme, self, &(*e).area);
	result = TRUE;
	return result;
}


static gboolean __lambda8__gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self) {
	gboolean result;
	result = _lambda8_ (event, self);
	return result;
}


static void _pasang_theme_switch_resize_gtk_widget_size_allocate (GtkWidget* _sender, GdkRectangle* allocation, gpointer self) {
	pasang_theme_switch_resize (self, allocation);
}


static void _lambda9_ (PasangGameView* self) {
	PasangTheme* _tmp0_ = NULL;
	_tmp0_ = pasang_theme_switch_get_theme (self->priv->_theme_switch);
	pasang_game_view_set_theme (self, _tmp0_);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static void __lambda9__pasang_theme_switch_changed (PasangThemeSwitch* _sender, gpointer self) {
	_lambda9_ (self);
}


static gboolean _lambda10_ (GtkWidget* s, GdkEventMotion* event, PasangGameView* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp0_ = pasang_game_view_get_input_allowed (self);
	if (_tmp0_) {
		PasangPoint _tmp1_ = {0};
		PasangPoint _tmp2_ = {0};
		pasang_point_init_xy (&_tmp1_, (gint) (*event).x, (gint) (*event).y);
		_tmp2_ = _tmp1_;
		pasang_game_view_mouse_moved (self, &_tmp2_);
	}
	result = TRUE;
	return result;
}


static gboolean __lambda10__gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = _lambda10_ (_sender, event, self);
	return result;
}


static gboolean _lambda11_ (GtkWidget* s, GdkEventButton* event, PasangGameView* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp1_ = pasang_game_view_get_input_allowed (self);
	if (_tmp1_) {
		_tmp0_ = (*event).button == 1;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		PasangPoint _tmp2_ = {0};
		PasangPoint _tmp3_ = {0};
		pasang_point_init_xy (&_tmp2_, (gint) (*event).x, (gint) (*event).y);
		_tmp3_ = _tmp2_;
		pasang_game_view_mouse_pressed (self, &_tmp3_);
	}
	result = TRUE;
	return result;
}


static gboolean __lambda11__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = _lambda11_ (_sender, event, self);
	return result;
}


static gboolean _lambda12_ (GtkWidget* s, GdkEventButton* event, PasangGameView* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp1_ = pasang_game_view_get_input_allowed (self);
	if (_tmp1_) {
		_tmp0_ = (*event).button == 1;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		PasangPoint _tmp2_ = {0};
		PasangPoint _tmp3_ = {0};
		pasang_point_init_xy (&_tmp2_, (gint) (*event).x, (gint) (*event).y);
		_tmp3_ = _tmp2_;
		pasang_game_view_mouse_released (self, &_tmp3_);
	}
	result = TRUE;
	return result;
}


static gboolean __lambda12__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = _lambda12_ (_sender, event, self);
	return result;
}


PasangGameView* pasang_game_view_construct (GType object_type) {
	PasangGameView * self = NULL;
	PasangTheme* _tmp0_ = NULL;
	self = (PasangGameView*) g_object_new (object_type, NULL);
	pasang_game_view_set_turn (self, PASANG_PLAYER_AI, PASANG_PLAYER_HUMAN, 1);
	gtk_widget_set_size_request ((GtkWidget*) self, PASANG_BOARD_WIDTH * 30, PASANG_BOARD_WIDTH * 30);
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_POINTER_MOTION_MASK);
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_BUTTON_MOTION_MASK);
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_BUTTON_PRESS_MASK);
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_BUTTON_RELEASE_MASK);
	g_signal_connect_object ((GtkWidget*) self, "expose-event", (GCallback) __lambda8__gtk_widget_expose_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _pasang_theme_switch_resize_gtk_widget_size_allocate, self->priv->_theme_switch, 0);
	g_signal_connect_object (self->priv->_theme_switch, "changed", (GCallback) __lambda9__pasang_theme_switch_changed, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) __lambda10__gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __lambda11__gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) __lambda12__gtk_widget_button_release_event, self, 0);
	_tmp0_ = pasang_theme_switch_get_theme (self->priv->_theme_switch);
	pasang_game_view_set_theme (self, _tmp0_);
	pasang_game_view_init_state (self);
	return self;
}


PasangGameView* pasang_game_view_new (void) {
	return pasang_game_view_construct (PASANG_TYPE_GAME_VIEW);
}


static void pasang_game_view_init_state (PasangGameView* self) {
	g_return_if_fail (self != NULL);
	self->priv->simulating_mouse = FALSE;
	pasang_game_view_set_selected_move (self, NULL);
	self->priv->move_submission = PASANG_MOVE_SUBMISSION_NULL;
	self->kas_point.x = -1;
	pasang_theme_drop_pieces (self->priv->_theme);
	pasang_theme_drop_kas (self->priv->_theme, self->priv->_game);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


void pasang_game_view_start_game (PasangGameView* self, const gchar* starting_pattern) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (starting_pattern != NULL);
	pasang_game_start (self->priv->_game, starting_pattern);
	pasang_game_view_init_state (self);
}


/**
     * top_player: Player who "sits" at the top
     * bottom_player: Player who "sits" at the bottom
     * first_player: who plays first, top_player (0) or bottom_player (1)
     */
void pasang_game_view_set_turn (PasangGameView* self, PasangPlayer top_player, PasangPlayer bottom_player, gint first_player) {
	g_return_if_fail (self != NULL);
	g_return_if_fail ((first_player == 0) || (first_player == 1));
	pasang_game_view_set_rotated (self, first_player == 1);
	self->priv->player_types[first_player] = top_player;
	self->priv->player_types[1 - first_player] = bottom_player;
}


/**
     * Score for the player at the top/bottom.
     * Not to be confused with Game.score[playerNumber]
     */
gint pasang_game_view_get_visual_score (PasangGameView* self, PasangPlayerSide ps) {
	gint result = 0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (!self->priv->_rotated) {
		_tmp0_ = (gint) ps;
	} else {
		_tmp0_ = 1 - ps;
	}
	result = self->priv->_game->score[_tmp0_];
	return result;
}


void pasang_game_view_queue_draw_piece (PasangGameView* self, gint position) {
	PasangPoint _tmp0_ = {0};
	PasangPoint _tmp1_ = {0};
	PasangPoint p;
	PasangPiece piece;
	gint _tmp2_ = 0;
	gint width;
	g_return_if_fail (self != NULL);
	pasang_game_view_to_point (self, position, &_tmp0_);
	_tmp1_ = _tmp0_;
	p = _tmp1_;
	piece = self->priv->_game->board[position];
	if (piece == PASANG_PIECE_EMPTY) {
		gint _tmp3_;
		_tmp3_ = pasang_theme_cell_width (self->priv->_theme);
		_tmp2_ = _tmp3_;
	} else {
		gint _tmp4_;
		_tmp4_ = pasang_theme_piece_image_width (self->priv->_theme, piece);
		_tmp2_ = _tmp4_;
	}
	width = _tmp2_;
	g_assert (width > 0);
	gtk_widget_queue_draw_area ((GtkWidget*) self, p.x - (width / 2), p.y - (width / 2), width, width);
}


void pasang_game_view_queue_draw_kas (PasangGameView* self) {
	PasangPiece _tmp0_;
	gint _tmp1_;
	gint width;
	g_return_if_fail (self != NULL);
	_tmp0_ = pasang_game_get_kas (self->priv->_game);
	_tmp1_ = pasang_theme_piece_image_width (self->priv->_theme, _tmp0_);
	width = _tmp1_;
	g_assert (width > 0);
	gtk_widget_queue_draw_area ((GtkWidget*) self, self->kas_point.x - (width / 2), self->kas_point.y - (width / 2), width, width);
}


static void pasang_game_view_mouse_moved (PasangGameView* self, PasangPoint* mouse) {
	PasangStage _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pasang_game_get_stage (self->priv->_game);
	switch (_tmp0_) {
		case PASANG_STAGE_OPENING:
		{
			PasangMove* _tmp1_ = NULL;
			PasangMove* _tmp2_;
			pasang_theme_drop_pieces (self->priv->_theme);
			_tmp1_ = pasang_game_view_find_move (self, mouse);
			_tmp2_ = _tmp1_;
			pasang_theme_pick_booties (self->priv->_theme, self->priv->_game, _tmp2_, FALSE);
			_g_object_unref0 (_tmp2_);
			break;
		}
		case PASANG_STAGE_SUB_SELECT:
		case PASANG_STAGE_SUB_MOVE:
		{
			PasangMove* _tmp3_ = NULL;
			PasangMove* _tmp4_;
			_tmp3_ = pasang_game_view_find_move (self, mouse);
			_tmp4_ = _tmp3_;
			_g_object_unref0 (_tmp4_);
			break;
		}
		case PASANG_STAGE_SELECT:
		{
			pasang_game_view_drag_candidate (self, mouse);
			break;
		}
		case PASANG_STAGE_MOVE:
		{
			pasang_game_view_drag_kas (self, mouse);
			break;
		}
		default:
		break;
	}
}


static void pasang_game_view_mouse_pressed (PasangGameView* self, PasangPoint* mouse) {
	PasangStage _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pasang_game_get_stage (self->priv->_game);
	switch (_tmp0_) {
		case PASANG_STAGE_OPENING:
		case PASANG_STAGE_SUB_SELECT:
		case PASANG_STAGE_SUB_MOVE:
		{
			PasangMove* _tmp1_ = NULL;
			PasangMove* _tmp2_;
			gboolean _tmp3_;
			_tmp1_ = pasang_game_view_find_move (self, mouse);
			_tmp2_ = _tmp1_;
			_tmp3_ = _tmp2_ != NULL;
			_g_object_unref0 (_tmp2_);
			if (_tmp3_) {
				pasang_game_leave_one_move (self->priv->_game, self->priv->_selected_move);
				pasang_game_view_submit_selected_move (self);
			}
			break;
		}
		case PASANG_STAGE_SELECT:
		{
			pasang_game_view_pick_candidate (self, mouse);
			break;
		}
		case PASANG_STAGE_MOVE:
		{
			pasang_game_view_pick_kas (self, mouse);
			break;
		}
		default:
		break;
	}
}


static void pasang_game_view_mouse_released (PasangGameView* self, PasangPoint* mouse) {
	PasangStage _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pasang_game_get_stage (self->priv->_game);
	switch (_tmp0_) {
		case PASANG_STAGE_SELECT:
		{
			pasang_game_view_drop_candidate (self, mouse);
			break;
		}
		case PASANG_STAGE_MOVE:
		{
			pasang_game_view_drop_kas (self, mouse);
			break;
		}
		default:
		break;
	}
}


/**
     * To be called only when the mouse gesture has been completed.
     * This will cause perform_selected_move() to be called from animate()
     */
static void pasang_game_view_submit_selected_move (PasangGameView* self) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->_selected_move != NULL);
	self->priv->move_submission = PASANG_MOVE_SUBMISSION_SUBMITTING;
	_tmp0_ = pasang_game_count_submoves (self->priv->_game, self->priv->_selected_move);
	if (_tmp0_ == 1) {
		pasang_theme_pick_booties (self->priv->_theme, self->priv->_game, self->priv->_selected_move, TRUE);
	}
	if (self->kas_point.x != (-1)) {
		gint _tmp1_;
		PasangPoint _tmp2_ = {0};
		PasangPoint _tmp3_ = {0};
		_tmp1_ = pasang_game_view_to_position (self, &self->kas_point);
		pasang_game_view_to_point (self, _tmp1_, &_tmp2_);
		_tmp3_ = _tmp2_;
		self->kas_point = _tmp3_;
		pasang_game_view_queue_draw_kas (self);
	}
}


/**
     * Actually perform the selected move by calling game.perform().
     * This is called from animate() only after the captured pieces 
     * are visually shown lifted off the board.
     */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void pasang_game_view_perform_selected_move (PasangGameView* self) {
	PasangMove* _tmp0_;
	PasangMove* applied_move;
	PasangStage _tmp1_;
	PasangStage context;
	PasangPlayer _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->move_submission == PASANG_MOVE_SUBMISSION_LIFTING);
	g_return_if_fail (self->priv->_selected_move != NULL);
	_tmp0_ = _g_object_ref0 (self->priv->_selected_move);
	applied_move = _tmp0_;
	_tmp1_ = pasang_game_get_stage (self->priv->_game);
	context = _tmp1_;
	_tmp2_ = pasang_game_view_get_player_type (self);
	pasang_game_perform (self->priv->_game, self->priv->_selected_move, _tmp2_ != PASANG_PLAYER_HUMAN);
	pasang_theme_drop_kas (self->priv->_theme, self->priv->_game);
	pasang_theme_drop_pieces (self->priv->_theme);
	gtk_widget_queue_draw ((GtkWidget*) self);
	pasang_game_view_set_selected_move (self, NULL);
	self->kas_point.x = -1;
	self->priv->move_submission = PASANG_MOVE_SUBMISSION_NULL;
	g_signal_emit_by_name (self, "next-move-signal", context, applied_move);
	_g_object_unref0 (applied_move);
}


/**
     * Find the move that captures the piece at the given screen location.
     * Side effect: set selected_move
     */
static PasangMove* pasang_game_view_find_move (PasangGameView* self, PasangPoint* mouse) {
	PasangMove* result = NULL;
	gint _tmp0_;
	gint position;
	PasangMove* _tmp5_ = NULL;
	PasangMove* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = pasang_game_view_to_position (self, mouse);
	position = _tmp0_;
	{
		PasangGameIterator* _tmp1_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp1_ = pasang_game_iterator (self->priv->_game);
		_move_it = _tmp1_;
		while (TRUE) {
			PasangMove* _tmp2_ = NULL;
			_tmp2_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp2_;
			if (!(move != NULL)) {
				break;
			}
			{
				gint* pos_collection;
				int pos_collection_length1;
				int pos_it;
				pos_collection = move->booties;
				pos_collection_length1 = move->booties_length1;
				for (pos_it = 0; pos_it < move->booties_length1; pos_it = pos_it + 1) {
					gint pos;
					pos = pos_collection[pos_it];
					{
						if (position == pos) {
							PasangMove* _tmp3_ = NULL;
							PasangMove* _tmp4_;
							_tmp3_ = move;
							pasang_game_view_set_selected_move (self, _tmp3_);
							_tmp4_ = _g_object_ref0 (_tmp3_);
							result = _tmp4_;
							_g_object_unref0 (move);
							_pasang_game_iterator_unref0 (_move_it);
							return result;
						}
					}
				}
			}
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	_tmp5_ = NULL;
	pasang_game_view_set_selected_move (self, _tmp5_);
	_tmp6_ = _g_object_ref0 (_tmp5_);
	result = _tmp6_;
	return result;
}


/**
     * Select a piece to be promoted to kas. The candidate must be within
     * the vicinity of the mouse pointer.
     * Side effect: selected_move, kas_point, drag_point
     */
static void pasang_game_view_pick_candidate (PasangGameView* self, PasangPoint* mouse) {
	gint _tmp0_;
	gint position;
	g_return_if_fail (self != NULL);
	pasang_game_view_set_selected_move (self, NULL);
	_tmp0_ = pasang_game_view_to_position (self, mouse);
	position = _tmp0_;
	{
		PasangGameIterator* _tmp1_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp1_ = pasang_game_iterator (self->priv->_game);
		_move_it = _tmp1_;
		while (TRUE) {
			PasangMove* _tmp2_ = NULL;
			gint _tmp3_;
			_tmp2_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp2_;
			if (!(move != NULL)) {
				break;
			}
			_tmp3_ = pasang_move_get_position (move);
			if (position == _tmp3_) {
				PasangPoint _tmp4_ = {0};
				PasangPoint _tmp5_ = {0};
				PasangPoint _tmp6_ = {0};
				PasangPoint _tmp7_ = {0};
				pasang_game_view_set_selected_move (self, move);
				pasang_game_view_to_point (self, position, &_tmp4_);
				_tmp5_ = _tmp4_;
				self->kas_point = _tmp5_;
				pasang_point_init_xy (&_tmp6_, self->kas_point.x - (*mouse).x, self->kas_point.y - (*mouse).y);
				_tmp7_ = _tmp6_;
				self->priv->drag_point = _tmp7_;
				pasang_game_view_queue_draw_kas (self);
				pasang_theme_pick_kas (self->priv->_theme, self->priv->_game);
				break;
			}
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
}


/**
     * If there was a selected candidate, drag it. If it goes to the
     * empty column (which was captured during the opening move), highlight 
     * all its possible captures.
     * Side effect: kas_point
     * Return: true if the candidate is dragged home
     */
static gboolean pasang_game_view_drag_candidate (PasangGameView* self, PasangPoint* mouse) {
	gboolean result = FALSE;
	PasangPoint _tmp0_ = {0};
	PasangPoint _tmp1_ = {0};
	gint _tmp2_;
	gint pos;
	gint row;
	gint col;
	gint _tmp3_;
	gint kas_row;
	gint _tmp4_;
	gint empty_column;
	gboolean _tmp5_ = FALSE;
	gboolean dragged_home;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->_selected_move == NULL) {
		result = FALSE;
		return result;
	}
	pasang_game_view_queue_draw_kas (self);
	pasang_point_init_xy (&_tmp0_, (*mouse).x + self->priv->drag_point.x, (*mouse).y + self->priv->drag_point.y);
	_tmp1_ = _tmp0_;
	self->kas_point = _tmp1_;
	if (self->kas_point.x == (-1)) {
		self->kas_point.x = 0;
	}
	pasang_game_view_queue_draw_kas (self);
	_tmp2_ = pasang_game_view_to_position (self, &self->kas_point);
	pos = _tmp2_;
	row = pos / PASANG_BOARD_WIDTH;
	col = pos % PASANG_BOARD_WIDTH;
	_tmp3_ = pasang_move_get_position (self->priv->_selected_move);
	kas_row = _tmp3_ / PASANG_BOARD_WIDTH;
	_tmp4_ = pasang_game_get_player (self->priv->_game);
	empty_column = self->priv->_game->first_move[_tmp4_];
	if (row == kas_row) {
		_tmp5_ = col == empty_column;
	} else {
		_tmp5_ = FALSE;
	}
	dragged_home = _tmp5_;
	if (dragged_home) {
		{
			PasangGameIterator* _tmp6_ = NULL;
			PasangGameIterator* _move_it;
			PasangMove* move = NULL;
			_tmp6_ = pasang_game_iterator (self->priv->_game);
			_move_it = _tmp6_;
			while (TRUE) {
				PasangMove* _tmp7_ = NULL;
				gint _tmp8_;
				gint _tmp9_;
				_tmp7_ = pasang_game_iterator_next_value (_move_it);
				_g_object_unref0 (move);
				move = _tmp7_;
				if (!(move != NULL)) {
					break;
				}
				_tmp8_ = pasang_move_get_position (move);
				_tmp9_ = pasang_move_get_position (self->priv->_selected_move);
				if (_tmp8_ == _tmp9_) {
					pasang_theme_pick_booties (self->priv->_theme, self->priv->_game, move, FALSE);
				}
			}
			_g_object_unref0 (move);
			_pasang_game_iterator_unref0 (_move_it);
		}
		pasang_game_view_queue_draw_piece (self, pos);
	} else {
		pasang_theme_drop_pieces (self->priv->_theme);
	}
	result = dragged_home;
	return result;
}


/**
     * Promote the selected candidate to kas, if it is already dragged home.
     * Side effect: selected_move null if kas dropped elsewhere
     */
static void pasang_game_view_drop_candidate (PasangGameView* self, PasangPoint* mouse) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	if (self->priv->_selected_move == NULL) {
		return;
	}
	_tmp0_ = pasang_game_view_drag_candidate (self, mouse);
	if (_tmp0_) {
		pasang_game_view_submit_selected_move (self);
	} else {
		gint _tmp1_;
		_tmp1_ = pasang_move_get_position (self->priv->_selected_move);
		pasang_game_view_queue_draw_piece (self, _tmp1_);
		pasang_game_view_set_selected_move (self, NULL);
	}
	pasang_theme_drop_kas (self->priv->_theme, self->priv->_game);
}


/**
     * Pick the kas if the mouse is pointing at it.
     * Side effect: kas_point, drag_point
     */
static void pasang_game_view_pick_kas (PasangGameView* self, PasangPoint* mouse) {
	gint _tmp0_;
	gint pos;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pasang_game_view_to_position (self, mouse);
	pos = _tmp0_;
	_tmp1_ = pasang_game_get_player (self->priv->_game);
	if (pos == self->priv->_game->kas_position[_tmp1_]) {
		PasangPoint _tmp2_ = {0};
		PasangPoint _tmp3_ = {0};
		PasangPoint _tmp4_ = {0};
		PasangPoint _tmp5_ = {0};
		pasang_game_view_to_point (self, pos, &_tmp2_);
		_tmp3_ = _tmp2_;
		self->kas_point = _tmp3_;
		pasang_game_view_queue_draw_kas (self);
		pasang_point_init_xy (&_tmp4_, self->kas_point.x - (*mouse).x, self->kas_point.y - (*mouse).y);
		_tmp5_ = _tmp4_;
		self->priv->drag_point = _tmp5_;
		pasang_theme_pick_kas (self->priv->_theme, self->priv->_game);
	} else {
		self->kas_point.x = -1;
	}
}


/**
     * Drag the kas to follow the mouse. The kas must be previously picked.
     * Side effect: selected_move
     */
static void pasang_game_view_drag_kas (PasangGameView* self, PasangPoint* mouse) {
	PasangPoint _tmp0_ = {0};
	PasangPoint _tmp1_ = {0};
	gint _tmp2_;
	gint pos;
	g_return_if_fail (self != NULL);
	if (self->kas_point.x == (-1)) {
		return;
	}
	pasang_game_view_queue_draw_kas (self);
	pasang_point_init_xy (&_tmp0_, (*mouse).x + self->priv->drag_point.x, (*mouse).y + self->priv->drag_point.y);
	_tmp1_ = _tmp0_;
	self->kas_point = _tmp1_;
	if (self->kas_point.x == (-1)) {
		self->kas_point.x = 0;
	}
	pasang_game_view_queue_draw_kas (self);
	_tmp2_ = pasang_game_view_to_position (self, &self->kas_point);
	pos = _tmp2_;
	pasang_game_view_set_selected_move (self, NULL);
	pasang_theme_drop_pieces (self->priv->_theme);
	{
		PasangGameIterator* _tmp3_ = NULL;
		PasangGameIterator* _move_it;
		PasangMove* move = NULL;
		_tmp3_ = pasang_game_iterator (self->priv->_game);
		_move_it = _tmp3_;
		while (TRUE) {
			PasangMove* _tmp4_ = NULL;
			gint _tmp5_;
			_tmp4_ = pasang_game_iterator_next_value (_move_it);
			_g_object_unref0 (move);
			move = _tmp4_;
			if (!(move != NULL)) {
				break;
			}
			_tmp5_ = pasang_move_get_position (move);
			if (_tmp5_ == pos) {
				pasang_game_view_set_selected_move (self, move);
				{
					PasangGameIterator* _tmp6_ = NULL;
					PasangGameIterator* _m_it;
					PasangMove* m = NULL;
					_tmp6_ = pasang_game_iterator (self->priv->_game);
					_m_it = _tmp6_;
					while (TRUE) {
						PasangMove* _tmp7_ = NULL;
						gint _tmp8_;
						gint _tmp9_;
						_tmp7_ = pasang_game_iterator_next_value (_m_it);
						_g_object_unref0 (m);
						m = _tmp7_;
						if (!(m != NULL)) {
							break;
						}
						_tmp8_ = pasang_move_get_position (m);
						_tmp9_ = pasang_move_get_position (self->priv->_selected_move);
						if (_tmp8_ == _tmp9_) {
							pasang_theme_pick_booties (self->priv->_theme, self->priv->_game, m, FALSE);
						}
					}
					_g_object_unref0 (m);
					_pasang_game_iterator_unref0 (_m_it);
				}
				break;
			}
		}
		_g_object_unref0 (move);
		_pasang_game_iterator_unref0 (_move_it);
	}
	pasang_theme_pick_kas (self->priv->_theme, self->priv->_game);
}


/**
     * Drop the kas at the mouse location.
     */
static void pasang_game_view_drop_kas (PasangGameView* self, PasangPoint* mouse) {
	g_return_if_fail (self != NULL);
	if (self->kas_point.x == (-1)) {
		return;
	}
	pasang_game_view_drag_kas (self, mouse);
	if (self->priv->_selected_move != NULL) {
		pasang_game_view_submit_selected_move (self);
	} else {
		gint _tmp0_;
		self->kas_point.x = -1;
		_tmp0_ = pasang_game_get_player (self->priv->_game);
		pasang_game_view_queue_draw_piece (self, self->priv->_game->kas_position[_tmp0_]);
	}
	pasang_theme_drop_kas (self->priv->_theme, self->priv->_game);
}


static void pasang_game_view_to_point (PasangGameView* self, gint pos, PasangPoint* result) {
	PasangPoint _tmp0_ = {0};
	PasangPoint _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	pasang_theme_to_point (self->priv->_theme, pos, self->priv->_rotated, &_tmp0_);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


static gint pasang_game_view_to_position (PasangGameView* self, PasangPoint* p) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = pasang_theme_to_position (self->priv->_theme, self->priv->_game, p, self->priv->_rotated, self->priv->simulating_mouse);
	result = _tmp0_;
	return result;
}


/**
     * Call this to begin simulation of mouse events to effect the given move
     * Side effect: simulating_mouse, simulation_start_time, simulated_press_pos, simulated_release_pos
     */
void pasang_game_view_simulate (PasangGameView* self, PasangMove* move) {
	gint row;
	gint col;
	PasangStage _tmp0_;
	PasangStage _tmp9_;
	PasangPoint _tmp12_ = {0};
	PasangPoint _tmp13_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (move != NULL);
	g_return_if_fail (self->priv->simulating_mouse == FALSE);
	pasang_game_leave_one_move (self->priv->_game, move);
	row = 0;
	col = 0;
	_tmp0_ = pasang_game_get_stage (self->priv->_game);
	switch (_tmp0_) {
		case PASANG_STAGE_OPENING:
		{
			gint _tmp1_ = 0;
			gint _tmp2_;
			gint _tmp3_;
			_tmp2_ = pasang_game_get_player (self->priv->_game);
			if (_tmp2_ == 0) {
				_tmp1_ = 1;
			} else {
				_tmp1_ = 7;
			}
			row = _tmp1_;
			_tmp3_ = pasang_move_get_position (move);
			self->priv->simulated_press_pos = _tmp3_ + (row * PASANG_BOARD_WIDTH);
			self->priv->simulated_release_pos = self->priv->simulated_press_pos;
			break;
		}
		case PASANG_STAGE_SELECT:
		{
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			_tmp4_ = pasang_move_get_position (move);
			row = _tmp4_ / PASANG_BOARD_WIDTH;
			_tmp5_ = pasang_game_get_player (self->priv->_game);
			col = self->priv->_game->first_move[_tmp5_];
			_tmp6_ = pasang_move_get_position (move);
			self->priv->simulated_press_pos = _tmp6_;
			self->priv->simulated_release_pos = col + (row * PASANG_BOARD_WIDTH);
			break;
		}
		case PASANG_STAGE_MOVE:
		{
			gint _tmp7_;
			gint _tmp8_;
			_tmp7_ = pasang_game_get_player (self->priv->_game);
			self->priv->simulated_press_pos = self->priv->_game->kas_position[_tmp7_];
			_tmp8_ = pasang_move_get_position (move);
			self->priv->simulated_release_pos = _tmp8_;
			break;
		}
		default:
		break;
	}
	_tmp9_ = pasang_game_get_stage (self->priv->_game);
	if (_tmp9_ != PASANG_STAGE_OPENING) {
		PasangPoint _tmp10_ = {0};
		PasangPoint _tmp11_ = {0};
		pasang_game_view_to_point (self, self->priv->simulated_press_pos, &_tmp10_);
		_tmp11_ = _tmp10_;
		pasang_game_view_mouse_pressed (self, &_tmp11_);
	}
	pasang_game_view_to_point (self, self->priv->simulated_press_pos, &_tmp12_);
	_tmp13_ = _tmp12_;
	pasang_game_view_mouse_moved (self, &_tmp13_);
	self->priv->simulating_mouse = TRUE;
	g_timer_reset (self->priv->timer);
}


/**
     * Call this to prematurely stop simulating mouse events initiated by simulate()
     */
void pasang_game_view_stop_simulation (PasangGameView* self) {
	g_return_if_fail (self != NULL);
	pasang_game_view_init_state (self);
}


/**
     * Invoke this repeatedly.
     */
void pasang_game_view_animate (PasangGameView* self) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble lapse;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_timer_elapsed (self->priv->timer, NULL);
	_tmp1_ = pasang_theme_get_time_span (self->priv->_theme);
	lapse = _tmp0_ / _tmp1_;
	if (self->priv->simulating_mouse) {
		pasang_game_view_animate_simulated_mouse_events (self, lapse);
	}
	if (self->priv->move_submission == PASANG_MOVE_SUBMISSION_SUBMITTING) {
		self->priv->move_submission = PASANG_MOVE_SUBMISSION_LIFTING;
		g_timer_reset (self->priv->timer);
	} else {
		if (self->priv->move_submission == PASANG_MOVE_SUBMISSION_LIFTING) {
			gboolean _tmp2_ = FALSE;
			if (lapse >= 1.0) {
				_tmp2_ = TRUE;
			} else {
				gint _tmp3_;
				_tmp3_ = pasang_game_count_submoves (self->priv->_game, self->priv->_selected_move);
				_tmp2_ = _tmp3_ > 1;
			}
			if (_tmp2_) {
				pasang_game_view_perform_selected_move (self);
			}
		} else {
			gboolean _tmp4_ = FALSE;
			PasangPlayer _tmp5_;
			_tmp5_ = pasang_game_view_get_player_type (self);
			if (_tmp5_ == PASANG_PLAYER_HUMAN) {
				gboolean _tmp6_ = FALSE;
				PasangStage _tmp7_;
				_tmp7_ = pasang_game_get_stage (self->priv->_game);
				if (_tmp7_ == PASANG_STAGE_SUB_SELECT) {
					_tmp6_ = TRUE;
				} else {
					PasangStage _tmp8_;
					_tmp8_ = pasang_game_get_stage (self->priv->_game);
					_tmp6_ = _tmp8_ == PASANG_STAGE_SUB_MOVE;
				}
				_tmp4_ = _tmp6_;
			} else {
				_tmp4_ = FALSE;
			}
			if (_tmp4_) {
				gint _tmp9_;
				gint num_moves;
				gint n;
				PasangMove* _tmp10_ = NULL;
				_tmp9_ = pasang_game_numMoves (self->priv->_game);
				num_moves = _tmp9_;
				g_assert (num_moves > 1);
				n = ((gint) (lapse / 0.75)) % num_moves;
				pasang_theme_drop_pieces (self->priv->_theme);
				if (self->priv->_selected_move != NULL) {
					PasangMove* _tmp11_;
					_tmp11_ = _g_object_ref0 (self->priv->_selected_move);
					_g_object_unref0 (_tmp10_);
					_tmp10_ = _tmp11_;
				} else {
					PasangMove* _tmp12_ = NULL;
					_tmp12_ = pasang_game_getMove (self->priv->_game, n);
					_g_object_unref0 (_tmp10_);
					_tmp10_ = _tmp12_;
				}
				pasang_theme_pick_booties (self->priv->_theme, self->priv->_game, _tmp10_, FALSE);
				_g_object_unref0 (_tmp10_);
			}
		}
	}
	pasang_theme_animate (self->priv->_theme, self, lapse);
}


static void pasang_game_view_animate_simulated_mouse_events (PasangGameView* self, gdouble lapse) {
	PasangPlayer _tmp0_;
	PasangPoint _tmp1_ = {0};
	PasangPoint _tmp2_ = {0};
	PasangPoint simulated_press_point;
	PasangPoint _tmp3_ = {0};
	PasangPoint _tmp4_ = {0};
	PasangPoint simulated_release_point;
	PasangStage _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pasang_game_view_get_player_type (self);
	g_return_if_fail (_tmp0_ != PASANG_PLAYER_HUMAN);
	pasang_game_view_to_point (self, self->priv->simulated_press_pos, &_tmp1_);
	_tmp2_ = _tmp1_;
	simulated_press_point = _tmp2_;
	pasang_game_view_to_point (self, self->priv->simulated_release_pos, &_tmp3_);
	_tmp4_ = _tmp3_;
	simulated_release_point = _tmp4_;
	_tmp5_ = pasang_game_get_stage (self->priv->_game);
	if (_tmp5_ == PASANG_STAGE_OPENING) {
		if (lapse > 1) {
			pasang_game_view_mouse_pressed (self, &simulated_press_point);
			self->priv->simulating_mouse = FALSE;
		}
	} else {
		gdouble time_to_pick_kas;
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble distance;
		PasangPoint _tmp8_ = {0};
		PasangPoint _tmp9_ = {0};
		time_to_pick_kas = 0.5;
		_tmp6_ = MAX ((gdouble) 0, lapse - time_to_pick_kas);
		_tmp7_ = MIN (_tmp6_, 1.0);
		distance = _tmp7_;
		pasang_point_init_xy (&_tmp8_, (gint) ((simulated_press_point.x * (1 - distance)) + (simulated_release_point.x * distance)), (gint) ((simulated_press_point.y * (1 - distance)) + (simulated_release_point.y * distance)));
		_tmp9_ = _tmp8_;
		pasang_game_view_mouse_moved (self, &_tmp9_);
		if (distance == 1.0) {
			pasang_game_view_mouse_released (self, &simulated_release_point);
			self->priv->simulating_mouse = FALSE;
		}
	}
}


PasangGame* pasang_game_view_get_game (PasangGameView* self) {
	PasangGame* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_game;
	return result;
}


static void pasang_game_view_set_game (PasangGameView* self, PasangGame* value) {
	PasangGame* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_game);
	self->priv->_game = _tmp0_;
	g_object_notify ((GObject *) self, "game");
}


PasangThemeSwitch* pasang_game_view_get_theme_switch (PasangGameView* self) {
	PasangThemeSwitch* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_theme_switch;
	return result;
}


static void pasang_game_view_set_theme_switch (PasangGameView* self, PasangThemeSwitch* value) {
	PasangThemeSwitch* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_theme_switch);
	self->priv->_theme_switch = _tmp0_;
	g_object_notify ((GObject *) self, "theme-switch");
}


PasangTheme* pasang_game_view_get_theme (PasangGameView* self) {
	PasangTheme* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_theme;
	return result;
}


static void pasang_game_view_set_theme (PasangGameView* self, PasangTheme* value) {
	PasangTheme* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_theme);
	self->priv->_theme = _tmp0_;
	g_object_notify ((GObject *) self, "theme");
}


gboolean pasang_game_view_get_rotated (PasangGameView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_rotated;
	return result;
}


static void pasang_game_view_set_rotated (PasangGameView* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_rotated = value;
	g_object_notify ((GObject *) self, "rotated");
}


PasangMove* pasang_game_view_get_selected_move (PasangGameView* self) {
	PasangMove* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_selected_move;
	return result;
}


static void pasang_game_view_set_selected_move (PasangGameView* self, PasangMove* value) {
	PasangMove* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_selected_move);
	self->priv->_selected_move = _tmp0_;
	g_object_notify ((GObject *) self, "selected-move");
}


PasangPlayer pasang_game_view_get_player_type (PasangGameView* self) {
	PasangPlayer result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = pasang_game_get_player (self->priv->_game);
	result = self->priv->player_types[_tmp0_];
	return result;
}


PasangPlayerSide pasang_game_view_get_player_side (PasangGameView* self) {
	PasangPlayerSide result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (!self->priv->_rotated) {
		gint _tmp1_;
		_tmp1_ = pasang_game_get_player (self->priv->_game);
		_tmp0_ = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = pasang_game_get_player (self->priv->_game);
		_tmp0_ = 1 - _tmp2_;
	}
	result = (PasangPlayerSide) _tmp0_;
	return result;
}


static gboolean pasang_game_view_get_input_allowed (PasangGameView* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	PasangPlayer _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = pasang_game_view_get_player_type (self);
	if (_tmp1_ == PASANG_PLAYER_HUMAN) {
		_tmp0_ = self->priv->move_submission == PASANG_MOVE_SUBMISSION_NULL;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static void g_cclosure_user_marshal_VOID__ENUM_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_OBJECT) (gpointer data1, gint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ENUM_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void pasang_game_view_class_init (PasangGameViewClass * klass) {
	pasang_game_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PasangGameViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_pasang_game_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pasang_game_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = pasang_game_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_GAME, g_param_spec_object ("game", "game", "game", PASANG_TYPE_GAME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_THEME_SWITCH, g_param_spec_object ("theme-switch", "theme-switch", "theme-switch", PASANG_TYPE_THEME_SWITCH, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_THEME, g_param_spec_object ("theme", "theme", "theme", PASANG_TYPE_THEME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * When false, player 0 is drawn on top.
	     * When true, player 1 is drawn on top.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_ROTATED, g_param_spec_boolean ("rotated", "rotated", "rotated", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Move that matches the mouse gesture.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_SELECTED_MOVE, g_param_spec_object ("selected-move", "selected-move", "selected-move", PASANG_TYPE_MOVE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Who is playing next turn: Player.HUMAN, or Player.AI, or ...?
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_PLAYER_TYPE, g_param_spec_enum ("player-type", "player-type", "player-type", PASANG_TYPE_PLAYER, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Who is playing next turn: the player sitting at the top or the one at the bottom?
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PASANG_GAME_VIEW_PLAYER_SIDE, g_param_spec_enum ("player-side", "player-side", "player-side", PASANG_TYPE_PLAYER_SIDE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Emitted whenever a move has been completed.
	     */
	g_signal_new ("next_move_signal", PASANG_TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_OBJECT, G_TYPE_NONE, 2, PASANG_TYPE_STAGE, PASANG_TYPE_MOVE);
}


static void pasang_game_view_instance_init (PasangGameView * self) {
	PasangGame* _tmp0_ = NULL;
	PasangThemeSwitch* _tmp1_ = NULL;
	PasangPoint _tmp2_ = {0};
	PasangPoint _tmp3_ = {0};
	PasangPlayer* _tmp4_ = NULL;
	PasangPoint _tmp5_ = {0};
	PasangPoint _tmp6_ = {0};
	GTimer* _tmp7_ = NULL;
	self->priv = PASANG_GAME_VIEW_GET_PRIVATE (self);
	_tmp0_ = pasang_game_new ();
	self->priv->_game = _tmp0_;
	_tmp1_ = pasang_theme_switch_new ();
	self->priv->_theme_switch = _tmp1_;
	self->priv->_theme = NULL;
	self->priv->_rotated = FALSE;
	memset (&_tmp2_, 0, sizeof (PasangPoint));
	_tmp3_ = _tmp2_;
	self->kas_point = _tmp3_;
	self->priv->_selected_move = NULL;
	_tmp4_ = g_new0 (PasangPlayer, 2);
	self->priv->player_types = _tmp4_;
	self->priv->player_types_length1 = 2;
	self->priv->_player_types_size_ = self->priv->player_types_length1;
	memset (&_tmp5_, 0, sizeof (PasangPoint));
	_tmp6_ = _tmp5_;
	self->priv->drag_point = _tmp6_;
	_tmp7_ = g_timer_new ();
	self->priv->timer = _tmp7_;
}


static void pasang_game_view_finalize (GObject* obj) {
	PasangGameView * self;
	self = PASANG_GAME_VIEW (obj);
	_g_object_unref0 (self->priv->_game);
	_g_object_unref0 (self->priv->_theme_switch);
	_g_object_unref0 (self->priv->_theme);
	_g_object_unref0 (self->priv->_selected_move);
	self->priv->player_types = (g_free (self->priv->player_types), NULL);
	_g_timer_destroy0 (self->priv->timer);
	G_OBJECT_CLASS (pasang_game_view_parent_class)->finalize (obj);
}


GType pasang_game_view_get_type (void) {
	static volatile gsize pasang_game_view_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_game_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PasangGameViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pasang_game_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasangGameView), 0, (GInstanceInitFunc) pasang_game_view_instance_init, NULL };
		GType pasang_game_view_type_id;
		pasang_game_view_type_id = g_type_register_static (GTK_TYPE_DRAWING_AREA, "PasangGameView", &g_define_type_info, 0);
		g_once_init_leave (&pasang_game_view_type_id__volatile, pasang_game_view_type_id);
	}
	return pasang_game_view_type_id__volatile;
}


static void _vala_pasang_game_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PasangGameView * self;
	self = PASANG_GAME_VIEW (object);
	switch (property_id) {
		case PASANG_GAME_VIEW_GAME:
		g_value_set_object (value, pasang_game_view_get_game (self));
		break;
		case PASANG_GAME_VIEW_THEME_SWITCH:
		g_value_set_object (value, pasang_game_view_get_theme_switch (self));
		break;
		case PASANG_GAME_VIEW_THEME:
		g_value_set_object (value, pasang_game_view_get_theme (self));
		break;
		case PASANG_GAME_VIEW_ROTATED:
		g_value_set_boolean (value, pasang_game_view_get_rotated (self));
		break;
		case PASANG_GAME_VIEW_SELECTED_MOVE:
		g_value_set_object (value, pasang_game_view_get_selected_move (self));
		break;
		case PASANG_GAME_VIEW_PLAYER_TYPE:
		g_value_set_enum (value, pasang_game_view_get_player_type (self));
		break;
		case PASANG_GAME_VIEW_PLAYER_SIDE:
		g_value_set_enum (value, pasang_game_view_get_player_side (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pasang_game_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PasangGameView * self;
	self = PASANG_GAME_VIEW (object);
	switch (property_id) {
		case PASANG_GAME_VIEW_GAME:
		pasang_game_view_set_game (self, g_value_get_object (value));
		break;
		case PASANG_GAME_VIEW_THEME_SWITCH:
		pasang_game_view_set_theme_switch (self, g_value_get_object (value));
		break;
		case PASANG_GAME_VIEW_THEME:
		pasang_game_view_set_theme (self, g_value_get_object (value));
		break;
		case PASANG_GAME_VIEW_ROTATED:
		pasang_game_view_set_rotated (self, g_value_get_boolean (value));
		break;
		case PASANG_GAME_VIEW_SELECTED_MOVE:
		pasang_game_view_set_selected_move (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



