/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2008  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

namespace Pasang {

int main (string[] args) {
  if (args.length == 2) {
    if (args[1] == "--themes-path") {
      stdout.printf ("%s", Config.THEME_ROOT_DIR);
    }
    else {
      stdout.printf ("Usage:\n  %s\n  %s --themes-path\n", Config.PACKAGE_TARNAME, Config.PACKAGE_TARNAME);
    }
    return 0;
  }
  if (!Thread.supported()) {
    stderr.printf ("Cannot run without threads.\n");
    return 1;
  }
  
  // Localisation stuff
  Intl.bindtextdomain (Config.GETTEXT_PACKAGE, Config.LOCALEDIR);
  Intl.bind_textdomain_codeset (Config.GETTEXT_PACKAGE, "UTF-8");
  Intl.textdomain (Config.GETTEXT_PACKAGE);

  // Create user data directory
  var user_datadir = Path.build_filename (Environment.get_home_dir (), Config.USER_DATADIR);
  if (! FileUtils.test (user_datadir, FileTest.EXISTS)) {
    DirUtils.create (user_datadir, 0755);
  }

  // Main stuff
  Gtk.init (ref args);
  var window = new Pasang.Window ();
  window.show_all ();
  Gtk.main ();
  return 0;
}

}//namespace

// vim: tabstop=2: expandtab: textwidth=100: autoindent:
